#include <iostream>
#include <numeric>
#include <bits/stdc++.h>
using namespace std;
int funk(int k,int d [],int N)
{
    for(int i=0;i<N;i++)
    {
     if(k==d[i])
            return i;
    }
    return 0;
}
int fun(int k,int p [],int N,int d [])
{
    int br=0;
    int plaz=0;
    for(int i=0;i<k;i++)
    {
        if(funk(i,d,N)!=0)
            plaz+=p[funk(i,d,N)];
        if(plaz>0)
        {
            plaz--;
            br++;
        }
    }
    return br;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int N, Q;
    cin>>N>>Q;
    int d [N];
    int p [N];
    int u;
    for(int i=0;i<N;i++)
        cin>>d[i]>>p[i];
        int i,br,s,dan;
    while(Q>0)
    {
        dan=1;
        i=0;
        br=0;
        s=0;
     cin>>u;
     while(u>0)
     {
         if(d[i]==dan)
         {
             s+=p[i];
             i++;
         }
         if(s>0)
         {
             br++;
             s--;
         }
         u--;
         dan++;
     }
     cout<<br<<endl;
     Q--;
    }
}